# mattermost_dart (EXPERIMENTAL)
There is also a work-in-progress [Postman API reference](https://documenter.getpostman.com/view/4508214/RW8FERUn).


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 4.0.0
- Build package: org.openapitools.codegen.languages.DartDioNextClientCodegen

## Requirements

* Dart 2.12.0 or later OR Flutter 1.26.0 or later
* Dio 4.0.0+

## Installation & Usage

### pub.dev
To use the package from [pub.dev](https://pub.dev), please include the following in pubspec.yaml
```yaml
dependencies:
  mattermost_dart: 4.0.0
```

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```yaml
dependencies:
  mattermost_dart:
    git:
      url: https://github.com/tuyen-vuduc/mattermost-dart-openapi.git
      #ref: main
```

### Local development
To use the package from your local drive, please include the following in pubspec.yaml
```yaml
dependencies:
  mattermost_dart:
    path: /path/to/mattermost_dart
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:mattermost_dart/mattermost_dart.dart';


final api = MattermostDart().getAuthenticationApi();
final InlineObject26 inlineObject26 = ; // InlineObject26 | 

try {
    api.migrateAuthToLdap(inlineObject26);
} catch on DioError (e) {
    print("Exception when calling AuthenticationApi->migrateAuthToLdap: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *http://your-mattermost-url.com/api/v4*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
[*AuthenticationApi*](doc/AuthenticationApi.md) | [**migrateAuthToLdap**](doc/AuthenticationApi.md#migrateauthtoldap) | **POST** /users/migrate_auth/ldap | Migrate user accounts authentication type to LDAP.
[*AuthenticationApi*](doc/AuthenticationApi.md) | [**migrateAuthToSaml**](doc/AuthenticationApi.md#migrateauthtosaml) | **POST** /users/migrate_auth/saml | Migrate user accounts authentication type to SAML.
[*BleveApi*](doc/BleveApi.md) | [**purgeBleveIndexes**](doc/BleveApi.md#purgebleveindexes) | **POST** /bleve/purge_indexes | Purge all Bleve indexes
[*BotsApi*](doc/BotsApi.md) | [**assignBot**](doc/BotsApi.md#assignbot) | **POST** /bots/{bot_user_id}/assign/{user_id} | Assign a bot to a user
[*BotsApi*](doc/BotsApi.md) | [**convertBotToUser**](doc/BotsApi.md#convertbottouser) | **POST** /bots/{bot_user_id}/convert_to_user | Convert a bot into a user
[*BotsApi*](doc/BotsApi.md) | [**convertUserToBot**](doc/BotsApi.md#convertusertobot) | **POST** /users/{user_id}/convert_to_bot | Convert a user into a bot
[*BotsApi*](doc/BotsApi.md) | [**createBot**](doc/BotsApi.md#createbot) | **POST** /bots | Create a bot
[*BotsApi*](doc/BotsApi.md) | [**deleteBotIconImage**](doc/BotsApi.md#deleteboticonimage) | **DELETE** /bots/{bot_user_id}/icon | Delete bot&#39;s LHS icon image
[*BotsApi*](doc/BotsApi.md) | [**disableBot**](doc/BotsApi.md#disablebot) | **POST** /bots/{bot_user_id}/disable | Disable a bot
[*BotsApi*](doc/BotsApi.md) | [**enableBot**](doc/BotsApi.md#enablebot) | **POST** /bots/{bot_user_id}/enable | Enable a bot
[*BotsApi*](doc/BotsApi.md) | [**getBot**](doc/BotsApi.md#getbot) | **GET** /bots/{bot_user_id} | Get a bot
[*BotsApi*](doc/BotsApi.md) | [**getBotIconImage**](doc/BotsApi.md#getboticonimage) | **GET** /bots/{bot_user_id}/icon | Get bot&#39;s LHS icon
[*BotsApi*](doc/BotsApi.md) | [**getBots**](doc/BotsApi.md#getbots) | **GET** /bots | Get bots
[*BotsApi*](doc/BotsApi.md) | [**patchBot**](doc/BotsApi.md#patchbot) | **PUT** /bots/{bot_user_id} | Patch a bot
[*BotsApi*](doc/BotsApi.md) | [**setBotIconImage**](doc/BotsApi.md#setboticonimage) | **POST** /bots/{bot_user_id}/icon | Set bot&#39;s LHS icon image
[*BrandApi*](doc/BrandApi.md) | [**deleteBrandImage**](doc/BrandApi.md#deletebrandimage) | **DELETE** /brand/image | Delete current brand image
[*BrandApi*](doc/BrandApi.md) | [**getBrandImage**](doc/BrandApi.md#getbrandimage) | **GET** /brand/image | Get brand image
[*BrandApi*](doc/BrandApi.md) | [**uploadBrandImage**](doc/BrandApi.md#uploadbrandimage) | **POST** /brand/image | Upload brand image
[*ChannelsApi*](doc/ChannelsApi.md) | [**addChannelMember**](doc/ChannelsApi.md#addchannelmember) | **POST** /channels/{channel_id}/members | Add user to channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**autocompleteChannelsForTeam**](doc/ChannelsApi.md#autocompletechannelsforteam) | **GET** /teams/{team_id}/channels/autocomplete | Autocomplete channels
[*ChannelsApi*](doc/ChannelsApi.md) | [**autocompleteChannelsForTeamForSearch**](doc/ChannelsApi.md#autocompletechannelsforteamforsearch) | **GET** /teams/{team_id}/channels/search_autocomplete | Autocomplete channels for search
[*ChannelsApi*](doc/ChannelsApi.md) | [**channelMembersMinusGroupMembers**](doc/ChannelsApi.md#channelmembersminusgroupmembers) | **GET** /channels/{channel_id}/members_minus_group_members | Channel members minus group members.
[*ChannelsApi*](doc/ChannelsApi.md) | [**createChannel**](doc/ChannelsApi.md#createchannel) | **POST** /channels | Create a channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**createDirectChannel**](doc/ChannelsApi.md#createdirectchannel) | **POST** /channels/direct | Create a direct message channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**createGroupChannel**](doc/ChannelsApi.md#creategroupchannel) | **POST** /channels/group | Create a group message channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**createSidebarCategoryForTeamForUser**](doc/ChannelsApi.md#createsidebarcategoryforteamforuser) | **POST** /users/{user_id}/teams/{team_id}/channels/categories | Create user&#39;s sidebar category
[*ChannelsApi*](doc/ChannelsApi.md) | [**deleteChannel**](doc/ChannelsApi.md#deletechannel) | **DELETE** /channels/{channel_id} | Delete a channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**getAllChannels**](doc/ChannelsApi.md#getallchannels) | **GET** /channels | Get a list of all channels
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannel**](doc/ChannelsApi.md#getchannel) | **GET** /channels/{channel_id} | Get a channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelByName**](doc/ChannelsApi.md#getchannelbyname) | **GET** /teams/{team_id}/channels/name/{channel_name} | Get a channel by name
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelByNameForTeamName**](doc/ChannelsApi.md#getchannelbynameforteamname) | **GET** /teams/name/{team_name}/channels/name/{channel_name} | Get a channel by name and team name
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelMember**](doc/ChannelsApi.md#getchannelmember) | **GET** /channels/{channel_id}/members/{user_id} | Get channel member
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelMemberCountsByGroup**](doc/ChannelsApi.md#getchannelmembercountsbygroup) | **GET** /channels/{channel_id}/member_counts_by_group | Channel members counts for each group that has atleast one member in the channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelMembers**](doc/ChannelsApi.md#getchannelmembers) | **GET** /channels/{channel_id}/members | Get channel members
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelMembersByIds**](doc/ChannelsApi.md#getchannelmembersbyids) | **POST** /channels/{channel_id}/members/ids | Get channel members by ids
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelMembersForUser**](doc/ChannelsApi.md#getchannelmembersforuser) | **GET** /users/{user_id}/teams/{team_id}/channels/members | Get channel memberships and roles for a user
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelMembersTimezones**](doc/ChannelsApi.md#getchannelmemberstimezones) | **GET** /channels/{channel_id}/timezones | Get timezones in a channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelModerations**](doc/ChannelsApi.md#getchannelmoderations) | **GET** /channels/{channel_id}/moderations | Get information about channel&#39;s moderation.
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelStats**](doc/ChannelsApi.md#getchannelstats) | **GET** /channels/{channel_id}/stats | Get channel statistics
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelUnread**](doc/ChannelsApi.md#getchannelunread) | **GET** /users/{user_id}/channels/{channel_id}/unread | Get unread messages
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelsForTeamForUser**](doc/ChannelsApi.md#getchannelsforteamforuser) | **GET** /users/{user_id}/teams/{team_id}/channels | Get channels for user
[*ChannelsApi*](doc/ChannelsApi.md) | [**getChannelsForUser**](doc/ChannelsApi.md#getchannelsforuser) | **GET** /users/{user_id}/channels | Get all channels from all teams
[*ChannelsApi*](doc/ChannelsApi.md) | [**getDeletedChannelsForTeam**](doc/ChannelsApi.md#getdeletedchannelsforteam) | **GET** /teams/{team_id}/channels/deleted | Get deleted channels
[*ChannelsApi*](doc/ChannelsApi.md) | [**getPinnedPosts**](doc/ChannelsApi.md#getpinnedposts) | **GET** /channels/{channel_id}/pinned | Get a channel&#39;s pinned posts
[*ChannelsApi*](doc/ChannelsApi.md) | [**getPrivateChannelsForTeam**](doc/ChannelsApi.md#getprivatechannelsforteam) | **GET** /teams/{team_id}/channels/private | Get private channels
[*ChannelsApi*](doc/ChannelsApi.md) | [**getPublicChannelsByIdsForTeam**](doc/ChannelsApi.md#getpublicchannelsbyidsforteam) | **POST** /teams/{team_id}/channels/ids | Get a list of channels by ids
[*ChannelsApi*](doc/ChannelsApi.md) | [**getPublicChannelsForTeam**](doc/ChannelsApi.md#getpublicchannelsforteam) | **GET** /teams/{team_id}/channels | Get public channels
[*ChannelsApi*](doc/ChannelsApi.md) | [**getSidebarCategoriesForTeamForUser**](doc/ChannelsApi.md#getsidebarcategoriesforteamforuser) | **GET** /users/{user_id}/teams/{team_id}/channels/categories | Get user&#39;s sidebar categories
[*ChannelsApi*](doc/ChannelsApi.md) | [**getSidebarCategoryForTeamForUser**](doc/ChannelsApi.md#getsidebarcategoryforteamforuser) | **GET** /users/{user_id}/teams/{team_id}/channels/categories/{category_id} | Get sidebar category
[*ChannelsApi*](doc/ChannelsApi.md) | [**getSidebarCategoryOrderForTeamForUser**](doc/ChannelsApi.md#getsidebarcategoryorderforteamforuser) | **GET** /users/{user_id}/teams/{team_id}/channels/categories/order | Get user&#39;s sidebar category order
[*ChannelsApi*](doc/ChannelsApi.md) | [**moveChannel**](doc/ChannelsApi.md#movechannel) | **POST** /channels/{channel_id}/move | Move a channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**patchChannel**](doc/ChannelsApi.md#patchchannel) | **PUT** /channels/{channel_id}/patch | Patch a channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**patchChannelModerations**](doc/ChannelsApi.md#patchchannelmoderations) | **PUT** /channels/{channel_id}/moderations/patch | Update a channel&#39;s moderation settings.
[*ChannelsApi*](doc/ChannelsApi.md) | [**removeSidebarCategoryForTeamForUser**](doc/ChannelsApi.md#removesidebarcategoryforteamforuser) | **DELETE** /users/{user_id}/teams/{team_id}/channels/categories/{category_id} | Delete sidebar category
[*ChannelsApi*](doc/ChannelsApi.md) | [**removeUserFromChannel**](doc/ChannelsApi.md#removeuserfromchannel) | **DELETE** /channels/{channel_id}/members/{user_id} | Remove user from channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**restoreChannel**](doc/ChannelsApi.md#restorechannel) | **POST** /channels/{channel_id}/restore | Restore a channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**searchAllChannels**](doc/ChannelsApi.md#searchallchannels) | **POST** /channels/search | Search all private and open type channels across all teams
[*ChannelsApi*](doc/ChannelsApi.md) | [**searchArchivedChannels**](doc/ChannelsApi.md#searcharchivedchannels) | **POST** /teams/{team_id}/channels/search_archived | Search archived channels
[*ChannelsApi*](doc/ChannelsApi.md) | [**searchChannels**](doc/ChannelsApi.md#searchchannels) | **POST** /teams/{team_id}/channels/search | Search channels
[*ChannelsApi*](doc/ChannelsApi.md) | [**searchGroupChannels**](doc/ChannelsApi.md#searchgroupchannels) | **POST** /channels/group/search | Search Group Channels
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateChannel**](doc/ChannelsApi.md#updatechannel) | **PUT** /channels/{channel_id} | Update a channel
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateChannelMemberSchemeRoles**](doc/ChannelsApi.md#updatechannelmemberschemeroles) | **PUT** /channels/{channel_id}/members/{user_id}/schemeRoles | Update the scheme-derived roles of a channel member.
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateChannelNotifyProps**](doc/ChannelsApi.md#updatechannelnotifyprops) | **PUT** /channels/{channel_id}/members/{user_id}/notify_props | Update channel notifications
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateChannelPrivacy**](doc/ChannelsApi.md#updatechannelprivacy) | **PUT** /channels/{channel_id}/privacy | Update channel&#39;s privacy
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateChannelRoles**](doc/ChannelsApi.md#updatechannelroles) | **PUT** /channels/{channel_id}/members/{user_id}/roles | Update channel roles
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateChannelScheme**](doc/ChannelsApi.md#updatechannelscheme) | **PUT** /channels/{channel_id}/scheme | Set a channel&#39;s scheme
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateSidebarCategoriesForTeamForUser**](doc/ChannelsApi.md#updatesidebarcategoriesforteamforuser) | **PUT** /users/{user_id}/teams/{team_id}/channels/categories | Update user&#39;s sidebar categories
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateSidebarCategoryForTeamForUser**](doc/ChannelsApi.md#updatesidebarcategoryforteamforuser) | **PUT** /users/{user_id}/teams/{team_id}/channels/categories/{category_id} | Update sidebar category
[*ChannelsApi*](doc/ChannelsApi.md) | [**updateSidebarCategoryOrderForTeamForUser**](doc/ChannelsApi.md#updatesidebarcategoryorderforteamforuser) | **PUT** /users/{user_id}/teams/{team_id}/channels/categories/order | Update user&#39;s sidebar category order
[*ChannelsApi*](doc/ChannelsApi.md) | [**viewChannel**](doc/ChannelsApi.md#viewchannel) | **POST** /channels/members/{user_id}/view | View channel
[*CloudApi*](doc/CloudApi.md) | [**confirmCustomerPayment**](doc/CloudApi.md#confirmcustomerpayment) | **POST** /cloud/payment/confirm | Completes the payment setup intent
[*CloudApi*](doc/CloudApi.md) | [**createCustomerPayment**](doc/CloudApi.md#createcustomerpayment) | **POST** /cloud/payment | Create a customer setup payment intent
[*CloudApi*](doc/CloudApi.md) | [**getCloudCustomer**](doc/CloudApi.md#getcloudcustomer) | **GET** /cloud/customer | Get cloud customer
[*CloudApi*](doc/CloudApi.md) | [**getCloudProducts**](doc/CloudApi.md#getcloudproducts) | **GET** /cloud/products | Get cloud products
[*CloudApi*](doc/CloudApi.md) | [**getInvoiceForSubscriptionAsPdf**](doc/CloudApi.md#getinvoiceforsubscriptionaspdf) | **GET** /cloud/subscription/invoices/{invoice_id}/pdf | Get cloud invoice PDF
[*CloudApi*](doc/CloudApi.md) | [**getInvoicesForSubscription**](doc/CloudApi.md#getinvoicesforsubscription) | **GET** /cloud/subscription/invoices | Get cloud subscription invoices
[*CloudApi*](doc/CloudApi.md) | [**getSubscription**](doc/CloudApi.md#getsubscription) | **GET** /cloud/subscription | Get cloud subscription
[*CloudApi*](doc/CloudApi.md) | [**getSubscriptionStats**](doc/CloudApi.md#getsubscriptionstats) | **GET** /cloud/subscription/stats | GET endpoint for cloud subscription stats
[*CloudApi*](doc/CloudApi.md) | [**postEndpointForCwsWebhooks**](doc/CloudApi.md#postendpointforcwswebhooks) | **POST** /cloud/webhook | POST endpoint for CWS Webhooks
[*CloudApi*](doc/CloudApi.md) | [**sendAdminUpgradeRequestEmail**](doc/CloudApi.md#sendadminupgraderequestemail) | **POST** /cloud/subscription/limitreached/invite | POST endpoint for triggering sending emails to admin with request to upgrade workspace
[*CloudApi*](doc/CloudApi.md) | [**sendAdminUpgradeRequestEmailOnJoin**](doc/CloudApi.md#sendadminupgraderequestemailonjoin) | **POST** /cloud/subscription/limitreached/join | POST endpoint for triggering sending emails to admin with request to upgrade workspace
[*CloudApi*](doc/CloudApi.md) | [**updateCloudCustomer**](doc/CloudApi.md#updatecloudcustomer) | **PUT** /cloud/customer | Update cloud customer
[*CloudApi*](doc/CloudApi.md) | [**updateCloudCustomerAddress**](doc/CloudApi.md#updatecloudcustomeraddress) | **PUT** /cloud/customer/address | Update cloud customer address
[*ClusterApi*](doc/ClusterApi.md) | [**getClusterStatus**](doc/ClusterApi.md#getclusterstatus) | **GET** /cluster/status | Get cluster status
[*CommandsApi*](doc/CommandsApi.md) | [**createCommand**](doc/CommandsApi.md#createcommand) | **POST** /commands | Create a command
[*CommandsApi*](doc/CommandsApi.md) | [**deleteCommand**](doc/CommandsApi.md#deletecommand) | **DELETE** /commands/{command_id} | Delete a command
[*CommandsApi*](doc/CommandsApi.md) | [**executeCommand**](doc/CommandsApi.md#executecommand) | **POST** /commands/execute | Execute a command
[*CommandsApi*](doc/CommandsApi.md) | [**getCommandById**](doc/CommandsApi.md#getcommandbyid) | **GET** /commands/{command_id} | Get a command
[*CommandsApi*](doc/CommandsApi.md) | [**listAutocompleteCommands**](doc/CommandsApi.md#listautocompletecommands) | **GET** /teams/{team_id}/commands/autocomplete | List autocomplete commands
[*CommandsApi*](doc/CommandsApi.md) | [**listCommandAutocompleteSuggestions**](doc/CommandsApi.md#listcommandautocompletesuggestions) | **GET** /teams/{team_id}/commands/autocomplete_suggestions | List commands&#39; autocomplete data
[*CommandsApi*](doc/CommandsApi.md) | [**listCommands**](doc/CommandsApi.md#listcommands) | **GET** /commands | List commands for a team
[*CommandsApi*](doc/CommandsApi.md) | [**moveCommand**](doc/CommandsApi.md#movecommand) | **PUT** /commands/{command_id}/move | Move a command
[*CommandsApi*](doc/CommandsApi.md) | [**regenCommandToken**](doc/CommandsApi.md#regencommandtoken) | **PUT** /commands/{command_id}/regen_token | Generate a new token
[*CommandsApi*](doc/CommandsApi.md) | [**updateCommand**](doc/CommandsApi.md#updatecommand) | **PUT** /commands/{command_id} | Update a command
[*ComplianceApi*](doc/ComplianceApi.md) | [**createComplianceReport**](doc/ComplianceApi.md#createcompliancereport) | **POST** /compliance/reports | Create report
[*ComplianceApi*](doc/ComplianceApi.md) | [**downloadComplianceReport**](doc/ComplianceApi.md#downloadcompliancereport) | **GET** /compliance/reports/{report_id}/download | Download a report
[*ComplianceApi*](doc/ComplianceApi.md) | [**getComplianceReport**](doc/ComplianceApi.md#getcompliancereport) | **GET** /compliance/reports/{report_id} | Get a report
[*ComplianceApi*](doc/ComplianceApi.md) | [**getComplianceReports**](doc/ComplianceApi.md#getcompliancereports) | **GET** /compliance/reports | Get reports
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**addChannelsToRetentionPolicy**](doc/DataRetentionApi.md#addchannelstoretentionpolicy) | **POST** /data_retention/policies/{policy_id}/channels | Add channels to a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**addTeamsToRetentionPolicy**](doc/DataRetentionApi.md#addteamstoretentionpolicy) | **POST** /data_retention/policies/{policy_id}/teams | Add teams to a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**createDataRetentionPolicy**](doc/DataRetentionApi.md#createdataretentionpolicy) | **POST** /data_retention/policies | Create a new granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**deleteDataRetentionPolicy**](doc/DataRetentionApi.md#deletedataretentionpolicy) | **DELETE** /data_retention/policies/{policy_id} | Delete a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**getChannelPoliciesForUser**](doc/DataRetentionApi.md#getchannelpoliciesforuser) | **GET** /users/{user_id}/data_retention/channel_policies | Get the policies which are applied to a user&#39;s channels
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**getChannelsForRetentionPolicy**](doc/DataRetentionApi.md#getchannelsforretentionpolicy) | **GET** /data_retention/policies/{policy_id}/channels | Get the channels for a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**getDataRetentionPolicies**](doc/DataRetentionApi.md#getdataretentionpolicies) | **GET** /data_retention/policies | Get the granular data retention policies
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**getDataRetentionPoliciesCount**](doc/DataRetentionApi.md#getdataretentionpoliciescount) | **GET** /data_retention/policies_count | Get the number of granular data retention policies
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**getDataRetentionPolicy**](doc/DataRetentionApi.md#getdataretentionpolicy) | **GET** /data_retention/policy | Get the global data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**getDataRetentionPolicyByID**](doc/DataRetentionApi.md#getdataretentionpolicybyid) | **GET** /data_retention/policies/{policy_id} | Get a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**getTeamPoliciesForUser**](doc/DataRetentionApi.md#getteampoliciesforuser) | **GET** /users/{user_id}/data_retention/team_policies | Get the policies which are applied to a user&#39;s teams
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**getTeamsForRetentionPolicy**](doc/DataRetentionApi.md#getteamsforretentionpolicy) | **GET** /data_retention/policies/{policy_id}/teams | Get the teams for a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**patchDataRetentionPolicy**](doc/DataRetentionApi.md#patchdataretentionpolicy) | **PATCH** /data_retention/policies/{policy_id} | Patch a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**removeChannelsFromRetentionPolicy**](doc/DataRetentionApi.md#removechannelsfromretentionpolicy) | **DELETE** /data_retention/policies/{policy_id}/channels | Delete channels from a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**removeTeamsFromRetentionPolicy**](doc/DataRetentionApi.md#removeteamsfromretentionpolicy) | **DELETE** /data_retention/policies/{policy_id}/teams | Delete teams from a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**searchChannelsForRetentionPolicy**](doc/DataRetentionApi.md#searchchannelsforretentionpolicy) | **POST** /data_retention/policies/{policy_id}/channels/search | Search for the channels in a granular data retention policy
[*DataRetentionApi*](doc/DataRetentionApi.md) | [**searchTeamsForRetentionPolicy**](doc/DataRetentionApi.md#searchteamsforretentionpolicy) | **POST** /data_retention/policies/{policy_id}/teams/search | Search for the teams in a granular data retention policy
[*ElasticsearchApi*](doc/ElasticsearchApi.md) | [**purgeElasticsearchIndexes**](doc/ElasticsearchApi.md#purgeelasticsearchindexes) | **POST** /elasticsearch/purge_indexes | Purge all Elasticsearch indexes
[*ElasticsearchApi*](doc/ElasticsearchApi.md) | [**testElasticsearch**](doc/ElasticsearchApi.md#testelasticsearch) | **POST** /elasticsearch/test | Test Elasticsearch configuration
[*EmojiApi*](doc/EmojiApi.md) | [**autocompleteEmoji**](doc/EmojiApi.md#autocompleteemoji) | **GET** /emoji/autocomplete | Autocomplete custom emoji
[*EmojiApi*](doc/EmojiApi.md) | [**createEmoji**](doc/EmojiApi.md#createemoji) | **POST** /emoji | Create a custom emoji
[*EmojiApi*](doc/EmojiApi.md) | [**deleteEmoji**](doc/EmojiApi.md#deleteemoji) | **DELETE** /emoji/{emoji_id} | Delete a custom emoji
[*EmojiApi*](doc/EmojiApi.md) | [**getEmoji**](doc/EmojiApi.md#getemoji) | **GET** /emoji/{emoji_id} | Get a custom emoji
[*EmojiApi*](doc/EmojiApi.md) | [**getEmojiByName**](doc/EmojiApi.md#getemojibyname) | **GET** /emoji/name/{emoji_name} | Get a custom emoji by name
[*EmojiApi*](doc/EmojiApi.md) | [**getEmojiImage**](doc/EmojiApi.md#getemojiimage) | **GET** /emoji/{emoji_id}/image | Get custom emoji image
[*EmojiApi*](doc/EmojiApi.md) | [**getEmojiList**](doc/EmojiApi.md#getemojilist) | **GET** /emoji | Get a list of custom emoji
[*EmojiApi*](doc/EmojiApi.md) | [**searchEmoji**](doc/EmojiApi.md#searchemoji) | **POST** /emoji/search | Search custom emoji
[*ExportsApi*](doc/ExportsApi.md) | [**deleteExport**](doc/ExportsApi.md#deleteexport) | **DELETE** /exports/{export_name} | Delete an export file
[*ExportsApi*](doc/ExportsApi.md) | [**downloadExport**](doc/ExportsApi.md#downloadexport) | **GET** /exports/{export_name} | Download an export file
[*ExportsApi*](doc/ExportsApi.md) | [**listExports**](doc/ExportsApi.md#listexports) | **GET** /exports | List export files
[*FilesApi*](doc/FilesApi.md) | [**getFile**](doc/FilesApi.md#getfile) | **GET** /files/{file_id} | Get a file
[*FilesApi*](doc/FilesApi.md) | [**getFileInfo**](doc/FilesApi.md#getfileinfo) | **GET** /files/{file_id}/info | Get metadata for a file
[*FilesApi*](doc/FilesApi.md) | [**getFileLink**](doc/FilesApi.md#getfilelink) | **GET** /files/{file_id}/link | Get a public file link
[*FilesApi*](doc/FilesApi.md) | [**getFilePreview**](doc/FilesApi.md#getfilepreview) | **GET** /files/{file_id}/preview | Get a file&#39;s preview
[*FilesApi*](doc/FilesApi.md) | [**getFilePublic**](doc/FilesApi.md#getfilepublic) | **GET** /files/{file_id}/public | Get a public file
[*FilesApi*](doc/FilesApi.md) | [**getFileThumbnail**](doc/FilesApi.md#getfilethumbnail) | **GET** /files/{file_id}/thumbnail | Get a file&#39;s thumbnail
[*FilesApi*](doc/FilesApi.md) | [**searchFiles**](doc/FilesApi.md#searchfiles) | **POST** /teams/{team_id}/files/search | Search files in a team
[*FilesApi*](doc/FilesApi.md) | [**uploadFile**](doc/FilesApi.md#uploadfile) | **POST** /files | Upload a file
[*GroupsApi*](doc/GroupsApi.md) | [**getGroup**](doc/GroupsApi.md#getgroup) | **GET** /groups/{group_id} | Get a group
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupStats**](doc/GroupsApi.md#getgroupstats) | **GET** /groups/{group_id}/stats | Get group stats
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupSyncableForChannelId**](doc/GroupsApi.md#getgroupsyncableforchannelid) | **GET** /groups/{group_id}/channels/{channel_id} | Get GroupSyncable from channel ID
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupSyncableForTeamId**](doc/GroupsApi.md#getgroupsyncableforteamid) | **GET** /groups/{group_id}/teams/{team_id} | Get GroupSyncable from Team ID
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupSyncablesChannels**](doc/GroupsApi.md#getgroupsyncableschannels) | **GET** /groups/{group_id}/channels | Get group channels
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupSyncablesTeams**](doc/GroupsApi.md#getgroupsyncablesteams) | **GET** /groups/{group_id}/teams | Get group teams
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupUsers**](doc/GroupsApi.md#getgroupusers) | **GET** /groups/{group_id}/members | Get group users
[*GroupsApi*](doc/GroupsApi.md) | [**getGroups**](doc/GroupsApi.md#getgroups) | **GET** /groups | Get groups
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupsAssociatedToChannelsByTeam**](doc/GroupsApi.md#getgroupsassociatedtochannelsbyteam) | **GET** /teams/{team_id}/groups_by_channels | Get team groups by channels
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupsByChannel**](doc/GroupsApi.md#getgroupsbychannel) | **GET** /channels/{channel_id}/groups | Get channel groups
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupsByTeam**](doc/GroupsApi.md#getgroupsbyteam) | **GET** /teams/{team_id}/groups | Get team groups
[*GroupsApi*](doc/GroupsApi.md) | [**getGroupsByUserId**](doc/GroupsApi.md#getgroupsbyuserid) | **GET** /users/{user_id}/groups | Get groups for a userId
[*GroupsApi*](doc/GroupsApi.md) | [**linkGroupSyncableForChannel**](doc/GroupsApi.md#linkgroupsyncableforchannel) | **POST** /groups/{group_id}/channels/{channel_id}/link | Link a channel to a group
[*GroupsApi*](doc/GroupsApi.md) | [**linkGroupSyncableForTeam**](doc/GroupsApi.md#linkgroupsyncableforteam) | **POST** /groups/{group_id}/teams/{team_id}/link | Link a team to a group
[*GroupsApi*](doc/GroupsApi.md) | [**patchGroup**](doc/GroupsApi.md#patchgroup) | **PUT** /groups/{group_id}/patch | Patch a group
[*GroupsApi*](doc/GroupsApi.md) | [**patchGroupSyncableForChannel**](doc/GroupsApi.md#patchgroupsyncableforchannel) | **PUT** /groups/{group_id}/channels/{channel_id}/patch | Patch a GroupSyncable associated to Channel
[*GroupsApi*](doc/GroupsApi.md) | [**patchGroupSyncableForTeam**](doc/GroupsApi.md#patchgroupsyncableforteam) | **PUT** /groups/{group_id}/teams/{team_id}/patch | Patch a GroupSyncable associated to Team
[*GroupsApi*](doc/GroupsApi.md) | [**unlinkGroupSyncableForChannel**](doc/GroupsApi.md#unlinkgroupsyncableforchannel) | **DELETE** /groups/{group_id}/channels/{channel_id}/link | Delete a link from a channel to a group
[*GroupsApi*](doc/GroupsApi.md) | [**unlinkGroupSyncableForTeam**](doc/GroupsApi.md#unlinkgroupsyncableforteam) | **DELETE** /groups/{group_id}/teams/{team_id}/link | Delete a link from a team to a group
[*GroupsApi*](doc/GroupsApi.md) | [**unlinkLdapGroup**](doc/GroupsApi.md#unlinkldapgroup) | **DELETE** /ldap/groups/{remote_id}/link | Delete a link for LDAP group
[*ImportsApi*](doc/ImportsApi.md) | [**listImports**](doc/ImportsApi.md#listimports) | **GET** /imports | List import files
[*IntegrationActionsApi*](doc/IntegrationActionsApi.md) | [**openInteractiveDialog**](doc/IntegrationActionsApi.md#openinteractivedialog) | **POST** /actions/dialogs/open | Open a dialog
[*IntegrationActionsApi*](doc/IntegrationActionsApi.md) | [**submitInteractiveDialog**](doc/IntegrationActionsApi.md#submitinteractivedialog) | **POST** /actions/dialogs/submit | Submit a dialog
[*JobsApi*](doc/JobsApi.md) | [**cancelJob**](doc/JobsApi.md#canceljob) | **POST** /jobs/{job_id}/cancel | Cancel a job.
[*JobsApi*](doc/JobsApi.md) | [**createJob**](doc/JobsApi.md#createjob) | **POST** /jobs | Create a new job.
[*JobsApi*](doc/JobsApi.md) | [**downloadJob**](doc/JobsApi.md#downloadjob) | **GET** /jobs/{job_id}/download | Download the results of a job.
[*JobsApi*](doc/JobsApi.md) | [**getJob**](doc/JobsApi.md#getjob) | **GET** /jobs/{job_id} | Get a job.
[*JobsApi*](doc/JobsApi.md) | [**getJobs**](doc/JobsApi.md#getjobs) | **GET** /jobs | Get the jobs.
[*JobsApi*](doc/JobsApi.md) | [**getJobsByType**](doc/JobsApi.md#getjobsbytype) | **GET** /jobs/type/{type} | Get the jobs of the given type.
[*LDAPApi*](doc/LDAPApi.md) | [**deleteLdapPrivateCertificate**](doc/LDAPApi.md#deleteldapprivatecertificate) | **DELETE** /ldap/certificate/private | Remove private key
[*LDAPApi*](doc/LDAPApi.md) | [**deleteLdapPublicCertificate**](doc/LDAPApi.md#deleteldappubliccertificate) | **DELETE** /ldap/certificate/public | Remove public certificate
[*LDAPApi*](doc/LDAPApi.md) | [**migrateAuthToLdap**](doc/LDAPApi.md#migrateauthtoldap) | **POST** /users/migrate_auth/ldap | Migrate user accounts authentication type to LDAP.
[*LDAPApi*](doc/LDAPApi.md) | [**migrateIdLdap**](doc/LDAPApi.md#migrateidldap) | **POST** /ldap/migrateid | Migrate Id LDAP
[*LDAPApi*](doc/LDAPApi.md) | [**syncLdap**](doc/LDAPApi.md#syncldap) | **POST** /ldap/sync | Sync with LDAP
[*LDAPApi*](doc/LDAPApi.md) | [**testLdap**](doc/LDAPApi.md#testldap) | **POST** /ldap/test | Test LDAP configuration
[*LDAPApi*](doc/LDAPApi.md) | [**uploadLdapPrivateCertificate**](doc/LDAPApi.md#uploadldapprivatecertificate) | **POST** /ldap/certificate/private | Upload private key
[*LDAPApi*](doc/LDAPApi.md) | [**uploadLdapPublicCertificate**](doc/LDAPApi.md#uploadldappubliccertificate) | **POST** /ldap/certificate/public | Upload public certificate
[*LdapApi*](doc/LdapApi.md) | [**getLdapGroups**](doc/LdapApi.md#getldapgroups) | **GET** /ldap/groups | Returns a list of LDAP groups
[*LdapApi*](doc/LdapApi.md) | [**linkLdapGroup**](doc/LdapApi.md#linkldapgroup) | **POST** /ldap/groups/{remote_id}/link | Link a LDAP group
[*MigrateApi*](doc/MigrateApi.md) | [**migrateAuthToLdap**](doc/MigrateApi.md#migrateauthtoldap) | **POST** /users/migrate_auth/ldap | Migrate user accounts authentication type to LDAP.
[*MigrateApi*](doc/MigrateApi.md) | [**migrateAuthToSaml**](doc/MigrateApi.md#migrateauthtosaml) | **POST** /users/migrate_auth/saml | Migrate user accounts authentication type to SAML.
[*OAuthApi*](doc/OAuthApi.md) | [**createOAuthApp**](doc/OAuthApi.md#createoauthapp) | **POST** /oauth/apps | Register OAuth app
[*OAuthApi*](doc/OAuthApi.md) | [**deleteOAuthApp**](doc/OAuthApi.md#deleteoauthapp) | **DELETE** /oauth/apps/{app_id} | Delete an OAuth app
[*OAuthApi*](doc/OAuthApi.md) | [**getAuthorizedOAuthAppsForUser**](doc/OAuthApi.md#getauthorizedoauthappsforuser) | **GET** /users/{user_id}/oauth/apps/authorized | Get authorized OAuth apps
[*OAuthApi*](doc/OAuthApi.md) | [**getOAuthApp**](doc/OAuthApi.md#getoauthapp) | **GET** /oauth/apps/{app_id} | Get an OAuth app
[*OAuthApi*](doc/OAuthApi.md) | [**getOAuthAppInfo**](doc/OAuthApi.md#getoauthappinfo) | **GET** /oauth/apps/{app_id}/info | Get info on an OAuth app
[*OAuthApi*](doc/OAuthApi.md) | [**getOAuthApps**](doc/OAuthApi.md#getoauthapps) | **GET** /oauth/apps | Get OAuth apps
[*OAuthApi*](doc/OAuthApi.md) | [**regenerateOAuthAppSecret**](doc/OAuthApi.md#regenerateoauthappsecret) | **POST** /oauth/apps/{app_id}/regen_secret | Regenerate OAuth app secret
[*OAuthApi*](doc/OAuthApi.md) | [**updateOAuthApp**](doc/OAuthApi.md#updateoauthapp) | **PUT** /oauth/apps/{app_id} | Update an OAuth app
[*OpenGraphApi*](doc/OpenGraphApi.md) | [**openGraph**](doc/OpenGraphApi.md#opengraph) | **POST** /opengraph | Get open graph metadata for url
[*PermissionsApi*](doc/PermissionsApi.md) | [**getAncillaryPermissions**](doc/PermissionsApi.md#getancillarypermissions) | **GET** /permissions/ancillary | Return all system console subsection ancillary permissions
[*PluginsApi*](doc/PluginsApi.md) | [**disablePlugin**](doc/PluginsApi.md#disableplugin) | **POST** /plugins/{plugin_id}/disable | Disable plugin
[*PluginsApi*](doc/PluginsApi.md) | [**enablePlugin**](doc/PluginsApi.md#enableplugin) | **POST** /plugins/{plugin_id}/enable | Enable plugin
[*PluginsApi*](doc/PluginsApi.md) | [**getMarketplacePlugins**](doc/PluginsApi.md#getmarketplaceplugins) | **GET** /plugins/marketplace | Gets all the marketplace plugins
[*PluginsApi*](doc/PluginsApi.md) | [**getMarketplaceVisitedByAdmin**](doc/PluginsApi.md#getmarketplacevisitedbyadmin) | **GET** /plugins/marketplace/first_admin_visit | Get if the Plugin Marketplace has been visited by at least an admin.
[*PluginsApi*](doc/PluginsApi.md) | [**getPluginStatuses**](doc/PluginsApi.md#getpluginstatuses) | **GET** /plugins/statuses | Get plugins status
[*PluginsApi*](doc/PluginsApi.md) | [**getPlugins**](doc/PluginsApi.md#getplugins) | **GET** /plugins | Get plugins
[*PluginsApi*](doc/PluginsApi.md) | [**getWebappPlugins**](doc/PluginsApi.md#getwebappplugins) | **GET** /plugins/webapp | Get webapp plugins
[*PluginsApi*](doc/PluginsApi.md) | [**installMarketplacePlugin**](doc/PluginsApi.md#installmarketplaceplugin) | **POST** /plugins/marketplace | Installs a marketplace plugin
[*PluginsApi*](doc/PluginsApi.md) | [**installPluginFromUrl**](doc/PluginsApi.md#installpluginfromurl) | **POST** /plugins/install_from_url | Install plugin from url
[*PluginsApi*](doc/PluginsApi.md) | [**removePlugin**](doc/PluginsApi.md#removeplugin) | **DELETE** /plugins/{plugin_id} | Remove plugin
[*PluginsApi*](doc/PluginsApi.md) | [**uploadPlugin**](doc/PluginsApi.md#uploadplugin) | **POST** /plugins | Upload plugin
[*PostsApi*](doc/PostsApi.md) | [**createPost**](doc/PostsApi.md#createpost) | **POST** /posts | Create a post
[*PostsApi*](doc/PostsApi.md) | [**createPostEphemeral**](doc/PostsApi.md#createpostephemeral) | **POST** /posts/ephemeral | Create a ephemeral post
[*PostsApi*](doc/PostsApi.md) | [**deletePost**](doc/PostsApi.md#deletepost) | **DELETE** /posts/{post_id} | Delete a post
[*PostsApi*](doc/PostsApi.md) | [**doPostAction**](doc/PostsApi.md#dopostaction) | **POST** /posts/{post_id}/actions/{action_id} | Perform a post action
[*PostsApi*](doc/PostsApi.md) | [**getFileInfosForPost**](doc/PostsApi.md#getfileinfosforpost) | **GET** /posts/{post_id}/files/info | Get file info for post
[*PostsApi*](doc/PostsApi.md) | [**getFlaggedPostsForUser**](doc/PostsApi.md#getflaggedpostsforuser) | **GET** /users/{user_id}/posts/flagged | Get a list of flagged posts
[*PostsApi*](doc/PostsApi.md) | [**getPost**](doc/PostsApi.md#getpost) | **GET** /posts/{post_id} | Get a post
[*PostsApi*](doc/PostsApi.md) | [**getPostThread**](doc/PostsApi.md#getpostthread) | **GET** /posts/{post_id}/thread | Get a thread
[*PostsApi*](doc/PostsApi.md) | [**getPostsAroundLastUnread**](doc/PostsApi.md#getpostsaroundlastunread) | **GET** /users/{user_id}/channels/{channel_id}/posts/unread | Get posts around oldest unread
[*PostsApi*](doc/PostsApi.md) | [**getPostsByIds**](doc/PostsApi.md#getpostsbyids) | **POST** /posts/ids | Get posts by a list of ids
[*PostsApi*](doc/PostsApi.md) | [**getPostsForChannel**](doc/PostsApi.md#getpostsforchannel) | **GET** /channels/{channel_id}/posts | Get posts for a channel
[*PostsApi*](doc/PostsApi.md) | [**patchPost**](doc/PostsApi.md#patchpost) | **PUT** /posts/{post_id}/patch | Patch a post
[*PostsApi*](doc/PostsApi.md) | [**pinPost**](doc/PostsApi.md#pinpost) | **POST** /posts/{post_id}/pin | Pin a post to the channel
[*PostsApi*](doc/PostsApi.md) | [**searchPosts**](doc/PostsApi.md#searchposts) | **POST** /teams/{team_id}/posts/search | Search for team posts
[*PostsApi*](doc/PostsApi.md) | [**setPostUnread**](doc/PostsApi.md#setpostunread) | **POST** /users/{user_id}/posts/{post_id}/set_unread | Mark as unread from a post.
[*PostsApi*](doc/PostsApi.md) | [**unpinPost**](doc/PostsApi.md#unpinpost) | **POST** /posts/{post_id}/unpin | Unpin a post to the channel
[*PostsApi*](doc/PostsApi.md) | [**updatePost**](doc/PostsApi.md#updatepost) | **PUT** /posts/{post_id} | Update a post
[*PreferencesApi*](doc/PreferencesApi.md) | [**deletePreferences**](doc/PreferencesApi.md#deletepreferences) | **POST** /users/{user_id}/preferences/delete | Delete user&#39;s preferences
[*PreferencesApi*](doc/PreferencesApi.md) | [**getPreferences**](doc/PreferencesApi.md#getpreferences) | **GET** /users/{user_id}/preferences | Get the user&#39;s preferences
[*PreferencesApi*](doc/PreferencesApi.md) | [**getPreferencesByCategory**](doc/PreferencesApi.md#getpreferencesbycategory) | **GET** /users/{user_id}/preferences/{category} | List a user&#39;s preferences by category
[*PreferencesApi*](doc/PreferencesApi.md) | [**getPreferencesByCategoryByName**](doc/PreferencesApi.md#getpreferencesbycategorybyname) | **GET** /users/{user_id}/preferences/{category}/name/{preference_name} | Get a specific user preference
[*PreferencesApi*](doc/PreferencesApi.md) | [**updatePreferences**](doc/PreferencesApi.md#updatepreferences) | **PUT** /users/{user_id}/preferences | Save the user&#39;s preferences
[*ReactionsApi*](doc/ReactionsApi.md) | [**deleteReaction**](doc/ReactionsApi.md#deletereaction) | **DELETE** /users/{user_id}/posts/{post_id}/reactions/{emoji_name} | Remove a reaction from a post
[*ReactionsApi*](doc/ReactionsApi.md) | [**getBulkReactions**](doc/ReactionsApi.md#getbulkreactions) | **POST** /posts/ids/reactions | Bulk get the reaction for posts
[*ReactionsApi*](doc/ReactionsApi.md) | [**getReactions**](doc/ReactionsApi.md#getreactions) | **GET** /posts/{post_id}/reactions | Get a list of reactions to a post
[*ReactionsApi*](doc/ReactionsApi.md) | [**saveReaction**](doc/ReactionsApi.md#savereaction) | **POST** /reactions | Create a reaction
[*RolesApi*](doc/RolesApi.md) | [**getRole**](doc/RolesApi.md#getrole) | **GET** /roles/{role_id} | Get a role
[*RolesApi*](doc/RolesApi.md) | [**getRoleByName**](doc/RolesApi.md#getrolebyname) | **GET** /roles/name/{role_name} | Get a role
[*RolesApi*](doc/RolesApi.md) | [**getRolesByNames**](doc/RolesApi.md#getrolesbynames) | **POST** /roles/names | Get a list of roles by name
[*RolesApi*](doc/RolesApi.md) | [**patchRole**](doc/RolesApi.md#patchrole) | **PUT** /roles/{role_id}/patch | Patch a role
[*RolesApi*](doc/RolesApi.md) | [**rolesGet**](doc/RolesApi.md#rolesget) | **GET** /roles | Get a list of all the roles
[*RootApi*](doc/RootApi.md) | [**acknowledgeNotification**](doc/RootApi.md#acknowledgenotification) | **POST** /notifications/ack | Acknowledge receiving of a notification
[*SAMLApi*](doc/SAMLApi.md) | [**deleteSamlIdpCertificate**](doc/SAMLApi.md#deletesamlidpcertificate) | **DELETE** /saml/certificate/idp | Remove IDP certificate
[*SAMLApi*](doc/SAMLApi.md) | [**deleteSamlPrivateCertificate**](doc/SAMLApi.md#deletesamlprivatecertificate) | **DELETE** /saml/certificate/private | Remove private key
[*SAMLApi*](doc/SAMLApi.md) | [**deleteSamlPublicCertificate**](doc/SAMLApi.md#deletesamlpubliccertificate) | **DELETE** /saml/certificate/public | Remove public certificate
[*SAMLApi*](doc/SAMLApi.md) | [**getSamlCertificateStatus**](doc/SAMLApi.md#getsamlcertificatestatus) | **GET** /saml/certificate/status | Get certificate status
[*SAMLApi*](doc/SAMLApi.md) | [**getSamlMetadata**](doc/SAMLApi.md#getsamlmetadata) | **GET** /saml/metadata | Get metadata
[*SAMLApi*](doc/SAMLApi.md) | [**getSamlMetadataFromIdp**](doc/SAMLApi.md#getsamlmetadatafromidp) | **POST** /saml/metadatafromidp | Get metadata from Identity Provider
[*SAMLApi*](doc/SAMLApi.md) | [**migrateAuthToSaml**](doc/SAMLApi.md#migrateauthtosaml) | **POST** /users/migrate_auth/saml | Migrate user accounts authentication type to SAML.
[*SAMLApi*](doc/SAMLApi.md) | [**resetSamlAuthDataToEmail**](doc/SAMLApi.md#resetsamlauthdatatoemail) | **POST** /saml/reset_auth_data | Reset AuthData to Email
[*SAMLApi*](doc/SAMLApi.md) | [**uploadSamlIdpCertificate**](doc/SAMLApi.md#uploadsamlidpcertificate) | **POST** /saml/certificate/idp | Upload IDP certificate
[*SAMLApi*](doc/SAMLApi.md) | [**uploadSamlPrivateCertificate**](doc/SAMLApi.md#uploadsamlprivatecertificate) | **POST** /saml/certificate/private | Upload private key
[*SAMLApi*](doc/SAMLApi.md) | [**uploadSamlPublicCertificate**](doc/SAMLApi.md#uploadsamlpubliccertificate) | **POST** /saml/certificate/public | Upload public certificate
[*SchemesApi*](doc/SchemesApi.md) | [**createScheme**](doc/SchemesApi.md#createscheme) | **POST** /schemes | Create a scheme
[*SchemesApi*](doc/SchemesApi.md) | [**deleteScheme**](doc/SchemesApi.md#deletescheme) | **DELETE** /schemes/{scheme_id} | Delete a scheme
[*SchemesApi*](doc/SchemesApi.md) | [**getChannelsForScheme**](doc/SchemesApi.md#getchannelsforscheme) | **GET** /schemes/{scheme_id}/channels | Get a page of channels which use this scheme.
[*SchemesApi*](doc/SchemesApi.md) | [**getScheme**](doc/SchemesApi.md#getscheme) | **GET** /schemes/{scheme_id} | Get a scheme
[*SchemesApi*](doc/SchemesApi.md) | [**getSchemes**](doc/SchemesApi.md#getschemes) | **GET** /schemes | Get the schemes.
[*SchemesApi*](doc/SchemesApi.md) | [**getTeamsForScheme**](doc/SchemesApi.md#getteamsforscheme) | **GET** /schemes/{scheme_id}/teams | Get a page of teams which use this scheme.
[*SchemesApi*](doc/SchemesApi.md) | [**patchScheme**](doc/SchemesApi.md#patchscheme) | **PUT** /schemes/{scheme_id}/patch | Patch a scheme
[*SearchApi*](doc/SearchApi.md) | [**searchFiles**](doc/SearchApi.md#searchfiles) | **POST** /teams/{team_id}/files/search | Search files in a team
[*SharedChannelsApi*](doc/SharedChannelsApi.md) | [**getAllSharedChannels**](doc/SharedChannelsApi.md#getallsharedchannels) | **GET** /sharedchannels/{team_id} | Get all shared channels for team.
[*SharedChannelsApi*](doc/SharedChannelsApi.md) | [**getRemoteClusterInfo**](doc/SharedChannelsApi.md#getremoteclusterinfo) | **GET** /sharedchannels/remote_info/{remote_id} | Get remote cluster info by ID for user.
[*StatusApi*](doc/StatusApi.md) | [**getUserStatus**](doc/StatusApi.md#getuserstatus) | **GET** /users/{user_id}/status | Get user status
[*StatusApi*](doc/StatusApi.md) | [**getUsersStatusesByIds**](doc/StatusApi.md#getusersstatusesbyids) | **POST** /users/status/ids | Get user statuses by id
[*StatusApi*](doc/StatusApi.md) | [**postUserRecentCustomStatusDelete**](doc/StatusApi.md#postuserrecentcustomstatusdelete) | **POST** /users/{user_id}/status/custom/recent/delete | Delete user&#39;s recent custom status
[*StatusApi*](doc/StatusApi.md) | [**removeRecentCustomStatus**](doc/StatusApi.md#removerecentcustomstatus) | **DELETE** /users/{user_id}/status/custom/recent | Delete user&#39;s recent custom status
[*StatusApi*](doc/StatusApi.md) | [**unsetUserCustomStatus**](doc/StatusApi.md#unsetusercustomstatus) | **DELETE** /users/{user_id}/status/custom | Unsets user custom status
[*StatusApi*](doc/StatusApi.md) | [**updateUserCustomStatus**](doc/StatusApi.md#updateusercustomstatus) | **PUT** /users/{user_id}/status/custom | Update user custom status
[*StatusApi*](doc/StatusApi.md) | [**updateUserStatus**](doc/StatusApi.md#updateuserstatus) | **PUT** /users/{user_id}/status | Update user status
[*SystemApi*](doc/SystemApi.md) | [**checkIntegrity**](doc/SystemApi.md#checkintegrity) | **POST** /integrity | Perform a database integrity check
[*SystemApi*](doc/SystemApi.md) | [**clearServerBusy**](doc/SystemApi.md#clearserverbusy) | **DELETE** /server_busy | Clears the server busy (high load) flag
[*SystemApi*](doc/SystemApi.md) | [**databaseRecycle**](doc/SystemApi.md#databaserecycle) | **POST** /database/recycle | Recycle database connections
[*SystemApi*](doc/SystemApi.md) | [**generateSupportPacket**](doc/SystemApi.md#generatesupportpacket) | **GET** /system/support_packet | Download a zip file which contains helpful and useful information for troubleshooting your mattermost instance.
[*SystemApi*](doc/SystemApi.md) | [**getAnalyticsOld**](doc/SystemApi.md#getanalyticsold) | **GET** /analytics/old | Get analytics
[*SystemApi*](doc/SystemApi.md) | [**getAudits**](doc/SystemApi.md#getaudits) | **GET** /audits | Get audits
[*SystemApi*](doc/SystemApi.md) | [**getClientConfig**](doc/SystemApi.md#getclientconfig) | **GET** /config/client | Get client configuration
[*SystemApi*](doc/SystemApi.md) | [**getClientLicense**](doc/SystemApi.md#getclientlicense) | **GET** /license/client | Get client license
[*SystemApi*](doc/SystemApi.md) | [**getConfig**](doc/SystemApi.md#getconfig) | **GET** /config | Get configuration
[*SystemApi*](doc/SystemApi.md) | [**getEnvironmentConfig**](doc/SystemApi.md#getenvironmentconfig) | **GET** /config/environment | Get configuration made through environment variables
[*SystemApi*](doc/SystemApi.md) | [**getImageByUrl**](doc/SystemApi.md#getimagebyurl) | **GET** /image | Get an image by url
[*SystemApi*](doc/SystemApi.md) | [**getLogs**](doc/SystemApi.md#getlogs) | **GET** /logs | Get logs
[*SystemApi*](doc/SystemApi.md) | [**getNotices**](doc/SystemApi.md#getnotices) | **GET** /system/notices/{teamId} | Get notices for logged in user in specified team
[*SystemApi*](doc/SystemApi.md) | [**getPing**](doc/SystemApi.md#getping) | **GET** /system/ping | Check system health
[*SystemApi*](doc/SystemApi.md) | [**getRedirectLocation**](doc/SystemApi.md#getredirectlocation) | **GET** /redirect_location | Get redirect location
[*SystemApi*](doc/SystemApi.md) | [**getServerBusyExpires**](doc/SystemApi.md#getserverbusyexpires) | **GET** /server_busy | Get server busy expiry time.
[*SystemApi*](doc/SystemApi.md) | [**getSupportedTimezone**](doc/SystemApi.md#getsupportedtimezone) | **GET** /system/timezones | Retrieve a list of supported timezones
[*SystemApi*](doc/SystemApi.md) | [**getWarnMetricsStatus**](doc/SystemApi.md#getwarnmetricsstatus) | **GET** /warn_metrics/status | Get the warn metrics status (enabled or disabled)
[*SystemApi*](doc/SystemApi.md) | [**invalidateCaches**](doc/SystemApi.md#invalidatecaches) | **POST** /caches/invalidate | Invalidate all the caches
[*SystemApi*](doc/SystemApi.md) | [**markNoticesViewed**](doc/SystemApi.md#marknoticesviewed) | **PUT** /system/notices/view | Update notices as &#39;viewed&#39;
[*SystemApi*](doc/SystemApi.md) | [**patchConfig**](doc/SystemApi.md#patchconfig) | **PUT** /config/patch | Patch configuration
[*SystemApi*](doc/SystemApi.md) | [**postLog**](doc/SystemApi.md#postlog) | **POST** /logs | Add log message
[*SystemApi*](doc/SystemApi.md) | [**reloadConfig**](doc/SystemApi.md#reloadconfig) | **POST** /config/reload | Reload configuration
[*SystemApi*](doc/SystemApi.md) | [**removeLicenseFile**](doc/SystemApi.md#removelicensefile) | **DELETE** /license | Remove license file
[*SystemApi*](doc/SystemApi.md) | [**requestLicenseRenewalLink**](doc/SystemApi.md#requestlicenserenewallink) | **GET** /license/renewal | Request the license renewal link
[*SystemApi*](doc/SystemApi.md) | [**requestTrialLicense**](doc/SystemApi.md#requesttriallicense) | **POST** /trial-license | Request and install a trial license for your server
[*SystemApi*](doc/SystemApi.md) | [**restartServer**](doc/SystemApi.md#restartserver) | **POST** /restart | Restart the system after an upgrade from Team Edition to Enterprise Edition
[*SystemApi*](doc/SystemApi.md) | [**sendTrialLicenseWarnMetricAck**](doc/SystemApi.md#sendtriallicensewarnmetricack) | **POST** /warn_metrics/trial-license-ack/{warn_metric_id} | Request trial license and acknowledge a warning of a metric status
[*SystemApi*](doc/SystemApi.md) | [**sendWarnMetricAck**](doc/SystemApi.md#sendwarnmetricack) | **POST** /warn_metrics/ack/{warn_metric_id} | Acknowledge a warning of a metric status
[*SystemApi*](doc/SystemApi.md) | [**setServerBusy**](doc/SystemApi.md#setserverbusy) | **POST** /server_busy | Set the server busy (high load) flag
[*SystemApi*](doc/SystemApi.md) | [**testEmail**](doc/SystemApi.md#testemail) | **POST** /email/test | Send a test email
[*SystemApi*](doc/SystemApi.md) | [**testS3Connection**](doc/SystemApi.md#tests3connection) | **POST** /file/s3_test | Test AWS S3 connection
[*SystemApi*](doc/SystemApi.md) | [**testSiteURL**](doc/SystemApi.md#testsiteurl) | **POST** /site_url/test | Checks the validity of a Site URL
[*SystemApi*](doc/SystemApi.md) | [**trialLicensePrevGet**](doc/SystemApi.md#triallicenseprevget) | **GET** /trial-license/prev | Get last trial license used
[*SystemApi*](doc/SystemApi.md) | [**updateConfig**](doc/SystemApi.md#updateconfig) | **PUT** /config | Update configuration
[*SystemApi*](doc/SystemApi.md) | [**updateMarketplaceVisitedByAdmin**](doc/SystemApi.md#updatemarketplacevisitedbyadmin) | **POST** /plugins/marketplace/first_admin_visit | Stores that the Plugin Marketplace has been visited by at least an admin.
[*SystemApi*](doc/SystemApi.md) | [**upgradeToEnterprise**](doc/SystemApi.md#upgradetoenterprise) | **POST** /upgrade_to_enterprise | Executes an inplace upgrade from Team Edition to Enterprise Edition
[*SystemApi*](doc/SystemApi.md) | [**upgradeToEnterpriseStatus**](doc/SystemApi.md#upgradetoenterprisestatus) | **GET** /upgrade_to_enterprise/status | Get the current status for the inplace upgrade from Team Edition to Enterprise Edition
[*SystemApi*](doc/SystemApi.md) | [**uploadLicenseFile**](doc/SystemApi.md#uploadlicensefile) | **POST** /license | Upload license file
[*TeamsApi*](doc/TeamsApi.md) | [**addTeamMember**](doc/TeamsApi.md#addteammember) | **POST** /teams/{team_id}/members | Add user to team
[*TeamsApi*](doc/TeamsApi.md) | [**addTeamMemberFromInvite**](doc/TeamsApi.md#addteammemberfrominvite) | **POST** /teams/members/invite | Add user to team from invite
[*TeamsApi*](doc/TeamsApi.md) | [**addTeamMembers**](doc/TeamsApi.md#addteammembers) | **POST** /teams/{team_id}/members/batch | Add multiple users to team
[*TeamsApi*](doc/TeamsApi.md) | [**createTeam**](doc/TeamsApi.md#createteam) | **POST** /teams | Create a team
[*TeamsApi*](doc/TeamsApi.md) | [**getAllTeams**](doc/TeamsApi.md#getallteams) | **GET** /teams | Get teams
[*TeamsApi*](doc/TeamsApi.md) | [**getTeam**](doc/TeamsApi.md#getteam) | **GET** /teams/{team_id} | Get a team
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamByName**](doc/TeamsApi.md#getteambyname) | **GET** /teams/name/{name} | Get a team by name
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamIcon**](doc/TeamsApi.md#getteamicon) | **GET** /teams/{team_id}/image | Get the team icon
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamInviteInfo**](doc/TeamsApi.md#getteaminviteinfo) | **GET** /teams/invite/{invite_id} | Get invite info for a team
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamMember**](doc/TeamsApi.md#getteammember) | **GET** /teams/{team_id}/members/{user_id} | Get a team member
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamMembers**](doc/TeamsApi.md#getteammembers) | **GET** /teams/{team_id}/members | Get team members
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamMembersByIds**](doc/TeamsApi.md#getteammembersbyids) | **POST** /teams/{team_id}/members/ids | Get team members by ids
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamMembersForUser**](doc/TeamsApi.md#getteammembersforuser) | **GET** /users/{user_id}/teams/members | Get team members for a user
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamStats**](doc/TeamsApi.md#getteamstats) | **GET** /teams/{team_id}/stats | Get a team stats
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamUnread**](doc/TeamsApi.md#getteamunread) | **GET** /users/{user_id}/teams/{team_id}/unread | Get unreads for a team
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamsForUser**](doc/TeamsApi.md#getteamsforuser) | **GET** /users/{user_id}/teams | Get a user&#39;s teams
[*TeamsApi*](doc/TeamsApi.md) | [**getTeamsUnreadForUser**](doc/TeamsApi.md#getteamsunreadforuser) | **GET** /users/{user_id}/teams/unread | Get team unreads for a user
[*TeamsApi*](doc/TeamsApi.md) | [**importTeam**](doc/TeamsApi.md#importteam) | **POST** /teams/{team_id}/import | Import a Team from other application
[*TeamsApi*](doc/TeamsApi.md) | [**invalidateEmailInvites**](doc/TeamsApi.md#invalidateemailinvites) | **DELETE** /teams/invites/email | Invalidate active email invitations
[*TeamsApi*](doc/TeamsApi.md) | [**inviteGuestsToTeam**](doc/TeamsApi.md#invitegueststoteam) | **POST** /teams/{team_id}/invite-guests/email | Invite guests to the team by email
[*TeamsApi*](doc/TeamsApi.md) | [**inviteUsersToTeam**](doc/TeamsApi.md#inviteuserstoteam) | **POST** /teams/{team_id}/invite/email | Invite users to the team by email
[*TeamsApi*](doc/TeamsApi.md) | [**patchTeam**](doc/TeamsApi.md#patchteam) | **PUT** /teams/{team_id}/patch | Patch a team
[*TeamsApi*](doc/TeamsApi.md) | [**regenerateTeamInviteId**](doc/TeamsApi.md#regenerateteaminviteid) | **POST** /teams/{team_id}/regenerate_invite_id | Regenerate the Invite ID from a Team
[*TeamsApi*](doc/TeamsApi.md) | [**removeTeamIcon**](doc/TeamsApi.md#removeteamicon) | **DELETE** /teams/{team_id}/image | Remove the team icon
[*TeamsApi*](doc/TeamsApi.md) | [**removeTeamMember**](doc/TeamsApi.md#removeteammember) | **DELETE** /teams/{team_id}/members/{user_id} | Remove user from team
[*TeamsApi*](doc/TeamsApi.md) | [**restoreTeam**](doc/TeamsApi.md#restoreteam) | **POST** /teams/{team_id}/restore | Restore a team
[*TeamsApi*](doc/TeamsApi.md) | [**searchFiles**](doc/TeamsApi.md#searchfiles) | **POST** /teams/{team_id}/files/search | Search files in a team
[*TeamsApi*](doc/TeamsApi.md) | [**searchTeams**](doc/TeamsApi.md#searchteams) | **POST** /teams/search | Search teams
[*TeamsApi*](doc/TeamsApi.md) | [**setTeamIcon**](doc/TeamsApi.md#setteamicon) | **POST** /teams/{team_id}/image | Sets the team icon
[*TeamsApi*](doc/TeamsApi.md) | [**softDeleteTeam**](doc/TeamsApi.md#softdeleteteam) | **DELETE** /teams/{team_id} | Delete a team
[*TeamsApi*](doc/TeamsApi.md) | [**teamExists**](doc/TeamsApi.md#teamexists) | **GET** /teams/name/{name}/exists | Check if team exists
[*TeamsApi*](doc/TeamsApi.md) | [**teamMembersMinusGroupMembers**](doc/TeamsApi.md#teammembersminusgroupmembers) | **GET** /teams/{team_id}/members_minus_group_members | Team members minus group members.
[*TeamsApi*](doc/TeamsApi.md) | [**updateTeam**](doc/TeamsApi.md#updateteam) | **PUT** /teams/{team_id} | Update a team
[*TeamsApi*](doc/TeamsApi.md) | [**updateTeamMemberRoles**](doc/TeamsApi.md#updateteammemberroles) | **PUT** /teams/{team_id}/members/{user_id}/roles | Update a team member roles
[*TeamsApi*](doc/TeamsApi.md) | [**updateTeamMemberSchemeRoles**](doc/TeamsApi.md#updateteammemberschemeroles) | **PUT** /teams/{team_id}/members/{user_id}/schemeRoles | Update the scheme-derived roles of a team member.
[*TeamsApi*](doc/TeamsApi.md) | [**updateTeamPrivacy**](doc/TeamsApi.md#updateteamprivacy) | **PUT** /teams/{team_id}/privacy | Update teams&#39;s privacy
[*TeamsApi*](doc/TeamsApi.md) | [**updateTeamScheme**](doc/TeamsApi.md#updateteamscheme) | **PUT** /teams/{team_id}/scheme | Set a team&#39;s scheme
[*TermsOfServiceApi*](doc/TermsOfServiceApi.md) | [**createTermsOfService**](doc/TermsOfServiceApi.md#createtermsofservice) | **POST** /terms_of_service | Creates a new terms of service
[*TermsOfServiceApi*](doc/TermsOfServiceApi.md) | [**getTermsOfService**](doc/TermsOfServiceApi.md#gettermsofservice) | **GET** /terms_of_service | Get latest terms of service
[*TermsOfServiceApi*](doc/TermsOfServiceApi.md) | [**getUserTermsOfService**](doc/TermsOfServiceApi.md#getusertermsofservice) | **GET** /users/{user_id}/terms_of_service | Fetches user&#39;s latest terms of service action if the latest action was for acceptance.
[*TermsOfServiceApi*](doc/TermsOfServiceApi.md) | [**registerTermsOfServiceAction**](doc/TermsOfServiceApi.md#registertermsofserviceaction) | **POST** /users/{user_id}/terms_of_service | Records user action when they accept or decline custom terms of service
[*ThreadsApi*](doc/ThreadsApi.md) | [**getThreadMentionCountsByChannel**](doc/ThreadsApi.md#getthreadmentioncountsbychannel) | **GET** /users/{user_id}/teams/{team_id}/threads/mention_counts | Get all unread mention counts from followed threads, per-channel
[*ThreadsApi*](doc/ThreadsApi.md) | [**getUserThread**](doc/ThreadsApi.md#getuserthread) | **GET** /users/{user_id}/teams/{team_id}/threads/{thread_id} | Get a thread followed by the user
[*ThreadsApi*](doc/ThreadsApi.md) | [**getUserThreads**](doc/ThreadsApi.md#getuserthreads) | **GET** /users/{user_id}/teams/{team_id}/threads | Get all threads that user is following
[*ThreadsApi*](doc/ThreadsApi.md) | [**startFollowingThread**](doc/ThreadsApi.md#startfollowingthread) | **PUT** /users/{user_id}/teams/{team_id}/threads/{thread_id}/following | Start following a thread
[*ThreadsApi*](doc/ThreadsApi.md) | [**stopFollowingThread**](doc/ThreadsApi.md#stopfollowingthread) | **DELETE** /users/{user_id}/teams/{team_id}/threads/{thread_id}/following | Stop following a thread
[*ThreadsApi*](doc/ThreadsApi.md) | [**updateThreadReadForUser**](doc/ThreadsApi.md#updatethreadreadforuser) | **PUT** /users/{user_id}/teams/{team_id}/threads/{thread_id}/read/{timestamp} | Mark a thread that user is following read state to the timestamp
[*ThreadsApi*](doc/ThreadsApi.md) | [**updateThreadsReadForUser**](doc/ThreadsApi.md#updatethreadsreadforuser) | **PUT** /users/{user_id}/teams/{team_id}/threads/read | Mark all threads that user is following as read
[*UploadsApi*](doc/UploadsApi.md) | [**createUpload**](doc/UploadsApi.md#createupload) | **POST** /uploads | Create an upload
[*UploadsApi*](doc/UploadsApi.md) | [**getUpload**](doc/UploadsApi.md#getupload) | **GET** /uploads/{upload_id} | Get an upload session
[*UploadsApi*](doc/UploadsApi.md) | [**uploadData**](doc/UploadsApi.md#uploaddata) | **POST** /uploads/{upload_id} | Perform a file upload
[*UsersApi*](doc/UsersApi.md) | [**attachDeviceId**](doc/UsersApi.md#attachdeviceid) | **PUT** /users/sessions/device | Attach mobile device
[*UsersApi*](doc/UsersApi.md) | [**autocompleteUsers**](doc/UsersApi.md#autocompleteusers) | **GET** /users/autocomplete | Autocomplete users
[*UsersApi*](doc/UsersApi.md) | [**checkUserMfa**](doc/UsersApi.md#checkusermfa) | **POST** /users/mfa | Check MFA
[*UsersApi*](doc/UsersApi.md) | [**convertBotToUser**](doc/UsersApi.md#convertbottouser) | **POST** /bots/{bot_user_id}/convert_to_user | Convert a bot into a user
[*UsersApi*](doc/UsersApi.md) | [**convertUserToBot**](doc/UsersApi.md#convertusertobot) | **POST** /users/{user_id}/convert_to_bot | Convert a user into a bot
[*UsersApi*](doc/UsersApi.md) | [**createUser**](doc/UsersApi.md#createuser) | **POST** /users | Create a user
[*UsersApi*](doc/UsersApi.md) | [**createUserAccessToken**](doc/UsersApi.md#createuseraccesstoken) | **POST** /users/{user_id}/tokens | Create a user access token
[*UsersApi*](doc/UsersApi.md) | [**deleteUser**](doc/UsersApi.md#deleteuser) | **DELETE** /users/{user_id} | Deactivate a user account.
[*UsersApi*](doc/UsersApi.md) | [**demoteUserToGuest**](doc/UsersApi.md#demoteusertoguest) | **POST** /users/{user_id}/demote | Demote a user to a guest
[*UsersApi*](doc/UsersApi.md) | [**disableUserAccessToken**](doc/UsersApi.md#disableuseraccesstoken) | **POST** /users/tokens/disable | Disable personal access token
[*UsersApi*](doc/UsersApi.md) | [**enableUserAccessToken**](doc/UsersApi.md#enableuseraccesstoken) | **POST** /users/tokens/enable | Enable personal access token
[*UsersApi*](doc/UsersApi.md) | [**generateMfaSecret**](doc/UsersApi.md#generatemfasecret) | **POST** /users/{user_id}/mfa/generate | Generate MFA secret
[*UsersApi*](doc/UsersApi.md) | [**getChannelMembersWithTeamDataForUser**](doc/UsersApi.md#getchannelmemberswithteamdataforuser) | **GET** /users/{user_id}/channel_members | Get all channel members from all teams for a user
[*UsersApi*](doc/UsersApi.md) | [**getDefaultProfileImage**](doc/UsersApi.md#getdefaultprofileimage) | **GET** /users/{user_id}/image/default | Return user&#39;s default (generated) profile image
[*UsersApi*](doc/UsersApi.md) | [**getKnownUsers**](doc/UsersApi.md#getknownusers) | **GET** /users/known | Get user IDs of known users
[*UsersApi*](doc/UsersApi.md) | [**getProfileImage**](doc/UsersApi.md#getprofileimage) | **GET** /users/{user_id}/image | Get user&#39;s profile image
[*UsersApi*](doc/UsersApi.md) | [**getSessions**](doc/UsersApi.md#getsessions) | **GET** /users/{user_id}/sessions | Get user&#39;s sessions
[*UsersApi*](doc/UsersApi.md) | [**getTotalUsersStats**](doc/UsersApi.md#gettotalusersstats) | **GET** /users/stats | Get total count of users in the system
[*UsersApi*](doc/UsersApi.md) | [**getTotalUsersStatsFiltered**](doc/UsersApi.md#gettotalusersstatsfiltered) | **GET** /users/stats/filtered | Get total count of users in the system matching the specified filters
[*UsersApi*](doc/UsersApi.md) | [**getUploadsForUser**](doc/UsersApi.md#getuploadsforuser) | **GET** /users/{user_id}/uploads | Get uploads for a user
[*UsersApi*](doc/UsersApi.md) | [**getUser**](doc/UsersApi.md#getuser) | **GET** /users/{user_id} | Get a user
[*UsersApi*](doc/UsersApi.md) | [**getUserAccessToken**](doc/UsersApi.md#getuseraccesstoken) | **GET** /users/tokens/{token_id} | Get a user access token
[*UsersApi*](doc/UsersApi.md) | [**getUserAccessTokens**](doc/UsersApi.md#getuseraccesstokens) | **GET** /users/tokens | Get user access tokens
[*UsersApi*](doc/UsersApi.md) | [**getUserAccessTokensForUser**](doc/UsersApi.md#getuseraccesstokensforuser) | **GET** /users/{user_id}/tokens | Get user access tokens
[*UsersApi*](doc/UsersApi.md) | [**getUserAudits**](doc/UsersApi.md#getuseraudits) | **GET** /users/{user_id}/audits | Get user&#39;s audits
[*UsersApi*](doc/UsersApi.md) | [**getUserByEmail**](doc/UsersApi.md#getuserbyemail) | **GET** /users/email/{email} | Get a user by email
[*UsersApi*](doc/UsersApi.md) | [**getUserByUsername**](doc/UsersApi.md#getuserbyusername) | **GET** /users/username/{username} | Get a user by username
[*UsersApi*](doc/UsersApi.md) | [**getUserTermsOfService**](doc/UsersApi.md#getusertermsofservice) | **GET** /users/{user_id}/terms_of_service | Fetches user&#39;s latest terms of service action if the latest action was for acceptance.
[*UsersApi*](doc/UsersApi.md) | [**getUsers**](doc/UsersApi.md#getusers) | **GET** /users | Get users
[*UsersApi*](doc/UsersApi.md) | [**getUsersByGroupChannelIds**](doc/UsersApi.md#getusersbygroupchannelids) | **POST** /users/group_channels | Get users by group channels ids
[*UsersApi*](doc/UsersApi.md) | [**getUsersByIds**](doc/UsersApi.md#getusersbyids) | **POST** /users/ids | Get users by ids
[*UsersApi*](doc/UsersApi.md) | [**getUsersByUsernames**](doc/UsersApi.md#getusersbyusernames) | **POST** /users/usernames | Get users by usernames
[*UsersApi*](doc/UsersApi.md) | [**login**](doc/UsersApi.md#login) | **POST** /users/login | Login to Mattermost server
[*UsersApi*](doc/UsersApi.md) | [**loginByCwsToken**](doc/UsersApi.md#loginbycwstoken) | **POST** /users/login/cws | Auto-Login to Mattermost server using CWS token
[*UsersApi*](doc/UsersApi.md) | [**logout**](doc/UsersApi.md#logout) | **POST** /users/logout | Logout from the Mattermost server
[*UsersApi*](doc/UsersApi.md) | [**migrateAuthToLdap**](doc/UsersApi.md#migrateauthtoldap) | **POST** /users/migrate_auth/ldap | Migrate user accounts authentication type to LDAP.
[*UsersApi*](doc/UsersApi.md) | [**migrateAuthToSaml**](doc/UsersApi.md#migrateauthtosaml) | **POST** /users/migrate_auth/saml | Migrate user accounts authentication type to SAML.
[*UsersApi*](doc/UsersApi.md) | [**patchUser**](doc/UsersApi.md#patchuser) | **PUT** /users/{user_id}/patch | Patch a user
[*UsersApi*](doc/UsersApi.md) | [**permanentDeleteAllUsers**](doc/UsersApi.md#permanentdeleteallusers) | **DELETE** /users | Permanent delete all users
[*UsersApi*](doc/UsersApi.md) | [**promoteGuestToUser**](doc/UsersApi.md#promoteguesttouser) | **POST** /users/{user_id}/promote | Promote a guest to user
[*UsersApi*](doc/UsersApi.md) | [**publishUserTyping**](doc/UsersApi.md#publishusertyping) | **POST** /users/{user_id}/typing | Publish a user typing websocket event.
[*UsersApi*](doc/UsersApi.md) | [**registerTermsOfServiceAction**](doc/UsersApi.md#registertermsofserviceaction) | **POST** /users/{user_id}/terms_of_service | Records user action when they accept or decline custom terms of service
[*UsersApi*](doc/UsersApi.md) | [**resetPassword**](doc/UsersApi.md#resetpassword) | **POST** /users/password/reset | Reset password
[*UsersApi*](doc/UsersApi.md) | [**revokeAllSessions**](doc/UsersApi.md#revokeallsessions) | **POST** /users/{user_id}/sessions/revoke/all | Revoke all active sessions for a user
[*UsersApi*](doc/UsersApi.md) | [**revokeSession**](doc/UsersApi.md#revokesession) | **POST** /users/{user_id}/sessions/revoke | Revoke a user session
[*UsersApi*](doc/UsersApi.md) | [**revokeSessionsFromAllUsers**](doc/UsersApi.md#revokesessionsfromallusers) | **POST** /users/sessions/revoke/all | Revoke all sessions from all users.
[*UsersApi*](doc/UsersApi.md) | [**revokeUserAccessToken**](doc/UsersApi.md#revokeuseraccesstoken) | **POST** /users/tokens/revoke | Revoke a user access token
[*UsersApi*](doc/UsersApi.md) | [**searchUserAccessTokens**](doc/UsersApi.md#searchuseraccesstokens) | **POST** /users/tokens/search | Search tokens
[*UsersApi*](doc/UsersApi.md) | [**searchUsers**](doc/UsersApi.md#searchusers) | **POST** /users/search | Search users
[*UsersApi*](doc/UsersApi.md) | [**sendPasswordResetEmail**](doc/UsersApi.md#sendpasswordresetemail) | **POST** /users/password/reset/send | Send password reset email
[*UsersApi*](doc/UsersApi.md) | [**sendVerificationEmail**](doc/UsersApi.md#sendverificationemail) | **POST** /users/email/verify/send | Send verification email
[*UsersApi*](doc/UsersApi.md) | [**setDefaultProfileImage**](doc/UsersApi.md#setdefaultprofileimage) | **DELETE** /users/{user_id}/image | Delete user&#39;s profile image
[*UsersApi*](doc/UsersApi.md) | [**setProfileImage**](doc/UsersApi.md#setprofileimage) | **POST** /users/{user_id}/image | Set user&#39;s profile image
[*UsersApi*](doc/UsersApi.md) | [**switchAccountType**](doc/UsersApi.md#switchaccounttype) | **POST** /users/login/switch | Switch login method
[*UsersApi*](doc/UsersApi.md) | [**updateUser**](doc/UsersApi.md#updateuser) | **PUT** /users/{user_id} | Update a user
[*UsersApi*](doc/UsersApi.md) | [**updateUserActive**](doc/UsersApi.md#updateuseractive) | **PUT** /users/{user_id}/active | Update user active status
[*UsersApi*](doc/UsersApi.md) | [**updateUserAuth**](doc/UsersApi.md#updateuserauth) | **PUT** /users/{user_id}/auth | Update a user&#39;s authentication method
[*UsersApi*](doc/UsersApi.md) | [**updateUserMfa**](doc/UsersApi.md#updateusermfa) | **PUT** /users/{user_id}/mfa | Update a user&#39;s MFA
[*UsersApi*](doc/UsersApi.md) | [**updateUserPassword**](doc/UsersApi.md#updateuserpassword) | **PUT** /users/{user_id}/password | Update a user&#39;s password
[*UsersApi*](doc/UsersApi.md) | [**updateUserRoles**](doc/UsersApi.md#updateuserroles) | **PUT** /users/{user_id}/roles | Update a user&#39;s roles
[*UsersApi*](doc/UsersApi.md) | [**verifyUserEmail**](doc/UsersApi.md#verifyuseremail) | **POST** /users/email/verify | Verify user email
[*UsersApi*](doc/UsersApi.md) | [**verifyUserEmailWithoutToken**](doc/UsersApi.md#verifyuseremailwithouttoken) | **POST** /users/{user_id}/email/verify/member | Verify user email by ID
[*WebhooksApi*](doc/WebhooksApi.md) | [**createIncomingWebhook**](doc/WebhooksApi.md#createincomingwebhook) | **POST** /hooks/incoming | Create an incoming webhook
[*WebhooksApi*](doc/WebhooksApi.md) | [**createOutgoingWebhook**](doc/WebhooksApi.md#createoutgoingwebhook) | **POST** /hooks/outgoing | Create an outgoing webhook
[*WebhooksApi*](doc/WebhooksApi.md) | [**deleteIncomingWebhook**](doc/WebhooksApi.md#deleteincomingwebhook) | **DELETE** /hooks/incoming/{hook_id} | Delete an incoming webhook
[*WebhooksApi*](doc/WebhooksApi.md) | [**deleteOutgoingWebhook**](doc/WebhooksApi.md#deleteoutgoingwebhook) | **DELETE** /hooks/outgoing/{hook_id} | Delete an outgoing webhook
[*WebhooksApi*](doc/WebhooksApi.md) | [**getIncomingWebhook**](doc/WebhooksApi.md#getincomingwebhook) | **GET** /hooks/incoming/{hook_id} | Get an incoming webhook
[*WebhooksApi*](doc/WebhooksApi.md) | [**getIncomingWebhooks**](doc/WebhooksApi.md#getincomingwebhooks) | **GET** /hooks/incoming | List incoming webhooks
[*WebhooksApi*](doc/WebhooksApi.md) | [**getOutgoingWebhook**](doc/WebhooksApi.md#getoutgoingwebhook) | **GET** /hooks/outgoing/{hook_id} | Get an outgoing webhook
[*WebhooksApi*](doc/WebhooksApi.md) | [**getOutgoingWebhooks**](doc/WebhooksApi.md#getoutgoingwebhooks) | **GET** /hooks/outgoing | List outgoing webhooks
[*WebhooksApi*](doc/WebhooksApi.md) | [**regenOutgoingHookToken**](doc/WebhooksApi.md#regenoutgoinghooktoken) | **POST** /hooks/outgoing/{hook_id}/regen_token | Regenerate the token for the outgoing webhook.
[*WebhooksApi*](doc/WebhooksApi.md) | [**updateIncomingWebhook**](doc/WebhooksApi.md#updateincomingwebhook) | **PUT** /hooks/incoming/{hook_id} | Update an incoming webhook
[*WebhooksApi*](doc/WebhooksApi.md) | [**updateOutgoingWebhook**](doc/WebhooksApi.md#updateoutgoingwebhook) | **PUT** /hooks/outgoing/{hook_id} | Update an outgoing webhook


## Documentation For Models

 - [ActionsDialogsOpenDialog](doc/ActionsDialogsOpenDialog.md)
 - [AddOn](doc/AddOn.md)
 - [Address](doc/Address.md)
 - [AppError](doc/AppError.md)
 - [Audit](doc/Audit.md)
 - [AutocompleteSuggestion](doc/AutocompleteSuggestion.md)
 - [Bot](doc/Bot.md)
 - [Channel](doc/Channel.md)
 - [ChannelData](doc/ChannelData.md)
 - [ChannelMember](doc/ChannelMember.md)
 - [ChannelMemberCountByGroup](doc/ChannelMemberCountByGroup.md)
 - [ChannelMemberWithTeamData](doc/ChannelMemberWithTeamData.md)
 - [ChannelMemberWithTeamDataAllOf](doc/ChannelMemberWithTeamDataAllOf.md)
 - [ChannelModeratedRole](doc/ChannelModeratedRole.md)
 - [ChannelModeratedRoles](doc/ChannelModeratedRoles.md)
 - [ChannelModeratedRolesPatch](doc/ChannelModeratedRolesPatch.md)
 - [ChannelModeration](doc/ChannelModeration.md)
 - [ChannelModerationPatch](doc/ChannelModerationPatch.md)
 - [ChannelNotifyProps](doc/ChannelNotifyProps.md)
 - [ChannelStats](doc/ChannelStats.md)
 - [ChannelUnread](doc/ChannelUnread.md)
 - [ChannelUnreadAt](doc/ChannelUnreadAt.md)
 - [ChannelWithTeamData](doc/ChannelWithTeamData.md)
 - [ChannelWithTeamDataAllOf](doc/ChannelWithTeamDataAllOf.md)
 - [CloudCustomer](doc/CloudCustomer.md)
 - [ClusterInfo](doc/ClusterInfo.md)
 - [Command](doc/Command.md)
 - [CommandResponse](doc/CommandResponse.md)
 - [Compliance](doc/Compliance.md)
 - [Config](doc/Config.md)
 - [ConfigAnalyticsSettings](doc/ConfigAnalyticsSettings.md)
 - [ConfigClusterSettings](doc/ConfigClusterSettings.md)
 - [ConfigComplianceSettings](doc/ConfigComplianceSettings.md)
 - [ConfigEmailSettings](doc/ConfigEmailSettings.md)
 - [ConfigFileSettings](doc/ConfigFileSettings.md)
 - [ConfigGitLabSettings](doc/ConfigGitLabSettings.md)
 - [ConfigLdapSettings](doc/ConfigLdapSettings.md)
 - [ConfigLocalizationSettings](doc/ConfigLocalizationSettings.md)
 - [ConfigLogSettings](doc/ConfigLogSettings.md)
 - [ConfigMetricsSettings](doc/ConfigMetricsSettings.md)
 - [ConfigNativeAppSettings](doc/ConfigNativeAppSettings.md)
 - [ConfigPasswordSettings](doc/ConfigPasswordSettings.md)
 - [ConfigPrivacySettings](doc/ConfigPrivacySettings.md)
 - [ConfigRateLimitSettings](doc/ConfigRateLimitSettings.md)
 - [ConfigSamlSettings](doc/ConfigSamlSettings.md)
 - [ConfigServiceSettings](doc/ConfigServiceSettings.md)
 - [ConfigSqlSettings](doc/ConfigSqlSettings.md)
 - [ConfigSupportSettings](doc/ConfigSupportSettings.md)
 - [ConfigTeamSettings](doc/ConfigTeamSettings.md)
 - [DataRetentionPolicy](doc/DataRetentionPolicy.md)
 - [DataRetentionPolicyAllOf](doc/DataRetentionPolicyAllOf.md)
 - [DataRetentionPolicyCreate](doc/DataRetentionPolicyCreate.md)
 - [DataRetentionPolicyForChannel](doc/DataRetentionPolicyForChannel.md)
 - [DataRetentionPolicyForTeam](doc/DataRetentionPolicyForTeam.md)
 - [DataRetentionPolicyWithTeamAndChannelCounts](doc/DataRetentionPolicyWithTeamAndChannelCounts.md)
 - [DataRetentionPolicyWithTeamAndChannelCountsAllOf](doc/DataRetentionPolicyWithTeamAndChannelCountsAllOf.md)
 - [DataRetentionPolicyWithTeamAndChannelIds](doc/DataRetentionPolicyWithTeamAndChannelIds.md)
 - [DataRetentionPolicyWithTeamAndChannelIdsAllOf](doc/DataRetentionPolicyWithTeamAndChannelIdsAllOf.md)
 - [DataRetentionPolicyWithoutId](doc/DataRetentionPolicyWithoutId.md)
 - [Emoji](doc/Emoji.md)
 - [EnvironmentConfig](doc/EnvironmentConfig.md)
 - [EnvironmentConfigAnalyticsSettings](doc/EnvironmentConfigAnalyticsSettings.md)
 - [EnvironmentConfigClusterSettings](doc/EnvironmentConfigClusterSettings.md)
 - [EnvironmentConfigComplianceSettings](doc/EnvironmentConfigComplianceSettings.md)
 - [EnvironmentConfigEmailSettings](doc/EnvironmentConfigEmailSettings.md)
 - [EnvironmentConfigFileSettings](doc/EnvironmentConfigFileSettings.md)
 - [EnvironmentConfigGitLabSettings](doc/EnvironmentConfigGitLabSettings.md)
 - [EnvironmentConfigLdapSettings](doc/EnvironmentConfigLdapSettings.md)
 - [EnvironmentConfigLocalizationSettings](doc/EnvironmentConfigLocalizationSettings.md)
 - [EnvironmentConfigLogSettings](doc/EnvironmentConfigLogSettings.md)
 - [EnvironmentConfigMetricsSettings](doc/EnvironmentConfigMetricsSettings.md)
 - [EnvironmentConfigNativeAppSettings](doc/EnvironmentConfigNativeAppSettings.md)
 - [EnvironmentConfigPasswordSettings](doc/EnvironmentConfigPasswordSettings.md)
 - [EnvironmentConfigRateLimitSettings](doc/EnvironmentConfigRateLimitSettings.md)
 - [EnvironmentConfigSamlSettings](doc/EnvironmentConfigSamlSettings.md)
 - [EnvironmentConfigServiceSettings](doc/EnvironmentConfigServiceSettings.md)
 - [EnvironmentConfigSqlSettings](doc/EnvironmentConfigSqlSettings.md)
 - [EnvironmentConfigSupportSettings](doc/EnvironmentConfigSupportSettings.md)
 - [EnvironmentConfigTeamSettings](doc/EnvironmentConfigTeamSettings.md)
 - [FileInfo](doc/FileInfo.md)
 - [FileInfoList](doc/FileInfoList.md)
 - [GlobalDataRetentionPolicy](doc/GlobalDataRetentionPolicy.md)
 - [Group](doc/Group.md)
 - [GroupSyncableChannel](doc/GroupSyncableChannel.md)
 - [GroupSyncableChannels](doc/GroupSyncableChannels.md)
 - [GroupSyncableTeam](doc/GroupSyncableTeam.md)
 - [GroupSyncableTeams](doc/GroupSyncableTeams.md)
 - [GroupWithSchemeAdmin](doc/GroupWithSchemeAdmin.md)
 - [IncomingWebhook](doc/IncomingWebhook.md)
 - [InlineObject](doc/InlineObject.md)
 - [InlineObject1](doc/InlineObject1.md)
 - [InlineObject10](doc/InlineObject10.md)
 - [InlineObject100](doc/InlineObject100.md)
 - [InlineObject101](doc/InlineObject101.md)
 - [InlineObject102](doc/InlineObject102.md)
 - [InlineObject103](doc/InlineObject103.md)
 - [InlineObject104](doc/InlineObject104.md)
 - [InlineObject105](doc/InlineObject105.md)
 - [InlineObject107](doc/InlineObject107.md)
 - [InlineObject109](doc/InlineObject109.md)
 - [InlineObject11](doc/InlineObject11.md)
 - [InlineObject12](doc/InlineObject12.md)
 - [InlineObject13](doc/InlineObject13.md)
 - [InlineObject14](doc/InlineObject14.md)
 - [InlineObject15](doc/InlineObject15.md)
 - [InlineObject16](doc/InlineObject16.md)
 - [InlineObject17](doc/InlineObject17.md)
 - [InlineObject18](doc/InlineObject18.md)
 - [InlineObject19](doc/InlineObject19.md)
 - [InlineObject2](doc/InlineObject2.md)
 - [InlineObject20](doc/InlineObject20.md)
 - [InlineObject21](doc/InlineObject21.md)
 - [InlineObject22](doc/InlineObject22.md)
 - [InlineObject23](doc/InlineObject23.md)
 - [InlineObject24](doc/InlineObject24.md)
 - [InlineObject25](doc/InlineObject25.md)
 - [InlineObject26](doc/InlineObject26.md)
 - [InlineObject27](doc/InlineObject27.md)
 - [InlineObject28](doc/InlineObject28.md)
 - [InlineObject29](doc/InlineObject29.md)
 - [InlineObject3](doc/InlineObject3.md)
 - [InlineObject30](doc/InlineObject30.md)
 - [InlineObject31](doc/InlineObject31.md)
 - [InlineObject32](doc/InlineObject32.md)
 - [InlineObject33](doc/InlineObject33.md)
 - [InlineObject34](doc/InlineObject34.md)
 - [InlineObject35](doc/InlineObject35.md)
 - [InlineObject36](doc/InlineObject36.md)
 - [InlineObject37](doc/InlineObject37.md)
 - [InlineObject39](doc/InlineObject39.md)
 - [InlineObject4](doc/InlineObject4.md)
 - [InlineObject40](doc/InlineObject40.md)
 - [InlineObject41](doc/InlineObject41.md)
 - [InlineObject43](doc/InlineObject43.md)
 - [InlineObject44](doc/InlineObject44.md)
 - [InlineObject45](doc/InlineObject45.md)
 - [InlineObject46](doc/InlineObject46.md)
 - [InlineObject47](doc/InlineObject47.md)
 - [InlineObject48](doc/InlineObject48.md)
 - [InlineObject49](doc/InlineObject49.md)
 - [InlineObject5](doc/InlineObject5.md)
 - [InlineObject50](doc/InlineObject50.md)
 - [InlineObject51](doc/InlineObject51.md)
 - [InlineObject52](doc/InlineObject52.md)
 - [InlineObject53](doc/InlineObject53.md)
 - [InlineObject54](doc/InlineObject54.md)
 - [InlineObject55](doc/InlineObject55.md)
 - [InlineObject56](doc/InlineObject56.md)
 - [InlineObject57](doc/InlineObject57.md)
 - [InlineObject58](doc/InlineObject58.md)
 - [InlineObject59](doc/InlineObject59.md)
 - [InlineObject6](doc/InlineObject6.md)
 - [InlineObject60](doc/InlineObject60.md)
 - [InlineObject61](doc/InlineObject61.md)
 - [InlineObject62](doc/InlineObject62.md)
 - [InlineObject65](doc/InlineObject65.md)
 - [InlineObject66](doc/InlineObject66.md)
 - [InlineObject67](doc/InlineObject67.md)
 - [InlineObject69](doc/InlineObject69.md)
 - [InlineObject7](doc/InlineObject7.md)
 - [InlineObject70](doc/InlineObject70.md)
 - [InlineObject71](doc/InlineObject71.md)
 - [InlineObject73](doc/InlineObject73.md)
 - [InlineObject74](doc/InlineObject74.md)
 - [InlineObject75](doc/InlineObject75.md)
 - [InlineObject76](doc/InlineObject76.md)
 - [InlineObject77](doc/InlineObject77.md)
 - [InlineObject81](doc/InlineObject81.md)
 - [InlineObject82](doc/InlineObject82.md)
 - [InlineObject85](doc/InlineObject85.md)
 - [InlineObject86](doc/InlineObject86.md)
 - [InlineObject87](doc/InlineObject87.md)
 - [InlineObject89](doc/InlineObject89.md)
 - [InlineObject9](doc/InlineObject9.md)
 - [InlineObject90](doc/InlineObject90.md)
 - [InlineObject91](doc/InlineObject91.md)
 - [InlineObject92](doc/InlineObject92.md)
 - [InlineObject93](doc/InlineObject93.md)
 - [InlineObject94](doc/InlineObject94.md)
 - [InlineObject95](doc/InlineObject95.md)
 - [InlineObject97](doc/InlineObject97.md)
 - [InlineObject98](doc/InlineObject98.md)
 - [InlineObject99](doc/InlineObject99.md)
 - [InlineResponse200](doc/InlineResponse200.md)
 - [InlineResponse2001](doc/InlineResponse2001.md)
 - [InlineResponse20010](doc/InlineResponse20010.md)
 - [InlineResponse20011](doc/InlineResponse20011.md)
 - [InlineResponse20012](doc/InlineResponse20012.md)
 - [InlineResponse20013](doc/InlineResponse20013.md)
 - [InlineResponse20014](doc/InlineResponse20014.md)
 - [InlineResponse20015](doc/InlineResponse20015.md)
 - [InlineResponse20016](doc/InlineResponse20016.md)
 - [InlineResponse20017](doc/InlineResponse20017.md)
 - [InlineResponse2002](doc/InlineResponse2002.md)
 - [InlineResponse2003](doc/InlineResponse2003.md)
 - [InlineResponse2004](doc/InlineResponse2004.md)
 - [InlineResponse2005](doc/InlineResponse2005.md)
 - [InlineResponse2006](doc/InlineResponse2006.md)
 - [InlineResponse2007](doc/InlineResponse2007.md)
 - [InlineResponse2008](doc/InlineResponse2008.md)
 - [InlineResponse2009](doc/InlineResponse2009.md)
 - [InlineResponse201](doc/InlineResponse201.md)
 - [IntegrityCheckResult](doc/IntegrityCheckResult.md)
 - [Invoice](doc/Invoice.md)
 - [InvoiceLineItem](doc/InvoiceLineItem.md)
 - [Job](doc/Job.md)
 - [LDAPGroup](doc/LDAPGroup.md)
 - [LDAPGroupsPaged](doc/LDAPGroupsPaged.md)
 - [LicenseRenewalLink](doc/LicenseRenewalLink.md)
 - [MarketplacePlugin](doc/MarketplacePlugin.md)
 - [Notice](doc/Notice.md)
 - [OAuthApp](doc/OAuthApp.md)
 - [OpenGraph](doc/OpenGraph.md)
 - [OpenGraphArticle](doc/OpenGraphArticle.md)
 - [OpenGraphArticleAuthors](doc/OpenGraphArticleAuthors.md)
 - [OpenGraphAudios](doc/OpenGraphAudios.md)
 - [OpenGraphBook](doc/OpenGraphBook.md)
 - [OpenGraphImages](doc/OpenGraphImages.md)
 - [OpenGraphVideos](doc/OpenGraphVideos.md)
 - [OrderedSidebarCategories](doc/OrderedSidebarCategories.md)
 - [OrphanedRecord](doc/OrphanedRecord.md)
 - [OutgoingWebhook](doc/OutgoingWebhook.md)
 - [PaymentMethod](doc/PaymentMethod.md)
 - [PaymentSetupIntent](doc/PaymentSetupIntent.md)
 - [PluginManifest](doc/PluginManifest.md)
 - [PluginManifestBackend](doc/PluginManifestBackend.md)
 - [PluginManifestServer](doc/PluginManifestServer.md)
 - [PluginManifestServerExecutables](doc/PluginManifestServerExecutables.md)
 - [PluginManifestWebapp](doc/PluginManifestWebapp.md)
 - [PluginStatus](doc/PluginStatus.md)
 - [Post](doc/Post.md)
 - [PostList](doc/PostList.md)
 - [PostListWithSearchMatches](doc/PostListWithSearchMatches.md)
 - [PostMetadata](doc/PostMetadata.md)
 - [PostMetadataEmbeds](doc/PostMetadataEmbeds.md)
 - [PostMetadataImages](doc/PostMetadataImages.md)
 - [PostsEphemeralPost](doc/PostsEphemeralPost.md)
 - [Preference](doc/Preference.md)
 - [Product](doc/Product.md)
 - [PushNotification](doc/PushNotification.md)
 - [Reaction](doc/Reaction.md)
 - [RelationalIntegrityCheckData](doc/RelationalIntegrityCheckData.md)
 - [RemoteClusterInfo](doc/RemoteClusterInfo.md)
 - [RetentionPolicyForChannelList](doc/RetentionPolicyForChannelList.md)
 - [RetentionPolicyForTeamList](doc/RetentionPolicyForTeamList.md)
 - [Role](doc/Role.md)
 - [SamlCertificateStatus](doc/SamlCertificateStatus.md)
 - [Scheme](doc/Scheme.md)
 - [ServerBusy](doc/ServerBusy.md)
 - [Session](doc/Session.md)
 - [SharedChannel](doc/SharedChannel.md)
 - [SidebarCategory](doc/SidebarCategory.md)
 - [SidebarCategoryWithChannels](doc/SidebarCategoryWithChannels.md)
 - [SlackAttachment](doc/SlackAttachment.md)
 - [SlackAttachmentField](doc/SlackAttachmentField.md)
 - [Status](doc/Status.md)
 - [StatusOK](doc/StatusOK.md)
 - [Subscription](doc/Subscription.md)
 - [SubscriptionStats](doc/SubscriptionStats.md)
 - [System](doc/System.md)
 - [SystemStatusResponse](doc/SystemStatusResponse.md)
 - [Team](doc/Team.md)
 - [TeamExists](doc/TeamExists.md)
 - [TeamMap](doc/TeamMap.md)
 - [TeamMember](doc/TeamMember.md)
 - [TeamStats](doc/TeamStats.md)
 - [TeamUnread](doc/TeamUnread.md)
 - [TermsOfService](doc/TermsOfService.md)
 - [Timezone](doc/Timezone.md)
 - [UploadSession](doc/UploadSession.md)
 - [User](doc/User.md)
 - [UserAccessToken](doc/UserAccessToken.md)
 - [UserAccessTokenSanitized](doc/UserAccessTokenSanitized.md)
 - [UserAuthData](doc/UserAuthData.md)
 - [UserAutocomplete](doc/UserAutocomplete.md)
 - [UserAutocompleteInChannel](doc/UserAutocompleteInChannel.md)
 - [UserAutocompleteInTeam](doc/UserAutocompleteInTeam.md)
 - [UserNotifyProps](doc/UserNotifyProps.md)
 - [UserTermsOfService](doc/UserTermsOfService.md)
 - [UserThread](doc/UserThread.md)
 - [UserThreads](doc/UserThreads.md)
 - [UsersStats](doc/UsersStats.md)


## Documentation For Authorization


## bearerAuth

- **Type**: HTTP basic authentication


## Author

feedback@mattermost.com

